<template>
	<div id="vairus-vue-app">

		<!-- MATRIX INFO -->
		
		<transition name="fade">
			<matrix-info
				v-if="matrix.status == 'info'"
				:matrix="matrix"
				@choosevairusformatrix="chooseVairusForMatrix"
				@closematrixinfo="closeMatrix"
			/>
		</transition>
		
		<!-- MATRIX SPAWN -->
		
		<transition name="fade">
			<div class="spawn matrix" 
				v-if="matrix.status == 'spawn'" 
				v-bind:style="getMatrixStyle" 
				v-on:click="openMatrixInfo"
				@contextmenu="closeMatrix"
			></div>
		</transition>
		
		<!-- WEBSITE ANALYZER -->
		
		<website-analyzer
			@closeanalyzerinfo="analyze = false"
			@checktutorial="checkSetTutorial"
			:active="analyze"
			:analyzer="analyzer"
			:old_analysis="old_analysis"
			:probes="probes"
		/>

		<!-- INFO REWARDS -->
		
		<transition name="fade">
			<info-rewards
				v-if="info_rewards != null" 
				:rewards="info_rewards"
				@closeinforewards="info_rewards = null"
			/>
		</transition>
		
		<!-- SPAWNS -->

		<transition name="fade">
			<glitched-image 
				class="spawn" 
				:class="spawn.type"
				v-if="spawn.active" 
				v-bind:style="getSpawnStyle" 
				:image="getSpawnImage"
				@click="clickSpawn($event, true)"
				@rightclick="clickSpawn($event, false)"
			/>
		</transition>
		
		<div class="shard-particles" v-bind:style="getParticeStyle" v-if="vairus_catch.active">
			<shard-particle v-for="n in 3" type="neutral" :key="'n'+n"></shard-particle>
			<div v-for="(value, type) in vairus_catch.shards">
				<shard-particle v-for="n in value" :type="type" :key="n"></shard-particle>
			</div>
		</div>
		
		
		<!-- VAIRUS CATCH -->
		
		<transition name="fade">
			<vairus-catch
				v-if="vairus_catch.vairus != null" 
				v-on:click.native="closeCatch"
				:vairus_catch="vairus_catch"
			/>
		</transition>
		
		<!-- TREASURE REWARDS -->
		
		<transition name="fade">
			<treasure-rewards
				v-if="treasure_rewards != null" 
				v-on:click.native="closeTreasure"
				:treasure="treasure_rewards"
			/>
		</transition>
		
		
		<!-- CHOOSE VAIRUS -->

		<transition name="fade">
			<div class="vairus-list-container" v-if="vairus_list.active" v-on:click.self="closeList">
				<div class="main-column" v-on:click.self="closeList">
					<div class="inner azure-gradient">
						<div class="wrapper">
							<keep-alive>
								<vairus-list 
									ref="main_list"
									:list="vairus_list.list" 
									:boxes="boxes" 
									:main="false" 
									:stats="true" 
									show_footer="false" 
									@clicked="clickList"
									@mounted="listMounted"
								/>
							</keep-alive>
						</div>
						
						<transition name="fade">
							<div class="loader" v-if="vairus_list.loading">
								<div class="loading">
									<div class="dot"></div>
									<div class="dot"></div>
									<div class="dot"></div>
								</div>
							</div>
						</transition>
					</div>
				</div>
			</div>
		</transition>
		
		
		<!-- NOTIFICATION -->
		
		<div class="vairus-messages">
			<transition-group name="message" tag="p">
				<div 
					class="vairus-message" 
					:class="['darkest'+notification.color+'-bkg', 'light'+notification.color+'-color']"
					v-for="(notification, index) in notifications" 
					v-bind:key="notification.id"
					v-bind:style="{'bottom' : (index*40)+10+'px !important'}"
					v-on:click="removeNotification(index)"
				>
					{{getLocale(notification.message)}}
				</div>
			</transition-group>
		</div>
		
		<!-- TUTORIAL -->
		
		<tutorial :tutorial_step="current_tutorial.flag" :color="tutorial_color"/>
		
		<!-- TOOLTIP -->
		
		<div class="tooltip lightestazure-border lightestazure-color" v-if="tooltipText" :style="tooltipStyle">
			{{tooltipText}}
		</div>
	</div>
</template>


<script>
	var browser = browser || chrome;
	import VButton from '../components/VButton.vue';
	import GlitchedImage from '../components/GlitchedImage.vue';
	import VairusList from '../components/VairusList.vue';
	import VairusCatch from '../components/VairusCatch.vue';
	import ShardParticle from '../components/ShardParticle.vue';
	import TreasureRewards from '../components/TreasureRewards.vue';
	import MatrixInfo from '../components/MatrixInfo.vue';
	import InfoRewards from '../components/InfoRewards.vue';
	import WebsiteAnalyzer from '../components/WebsiteAnalyzer.vue';
	import Tutorial from '../components/Tutorial.vue';
	import { commonMixin } from '../mixins/common.js';
	import { storeGettersMixin } from '../mixins/store_getters.js';
	import $ from "jquery";
	
	var all_elements;
		
	export default {
		props: ['options', 'tutorial'],
		data: function () {
			return{
				notifications : [],
				notifications_index : 0,
				screen : {
					width : 0,
					height : 0
				},
				spawn : {
					active : false,
					expiration : null,
					expiration_timeout : null,
					type : '',
					biome : null,
					unique_id : '',
					position : {
						left : 0, 
						top : 0
					}
				},
				vairus_catch : {
					active: false,
					vairus: null,
					shards: null,
					bytes: null
				},
				treasure_rewards : null,
				vairus_list : {
					active : false,
					loading : false,
					list : [],
					reason : ''
				},
				matrix : {
					status : false,
					level : null,
					selected_vairus : null,
					assigned_vairus : null,
					expiration : 0
				},
				info_rewards : null,
				analyze : false,
				analyzer : {},
				old_analysis : null,
				probes : [],
				boxes : [],
				show_popup : true,
				animation_started : false,
				animation_active : true
			}
		},
		created() {
			this.$store.commit('setOptions', this.options);
		
			window.addEventListener('resize', this.updateSize);
			window.addEventListener('orientationchange', this.updateSize);
			this.updateSize();
			
			document.addEventListener("visibilitychange", function(){
				if(document.visibilityState == 'visible'){
					this.checkVairusExpiration();
				} 
			}.bind(this));
			/* SERVER REQUEST */

			browser.runtime.sendMessage({
				type : 'navigate_url',
				data : { url : location.href }
			});
			
			browser.runtime.onMessage.addListener( function(request, sender, sendResponse) {
				switch(request.type){
					case 'spawn':
						this.addNotification(request.data.type+'_spawn');
						
						this.spawn.position.left = (Math.random()*0.9)+0.05;
						this.spawn.position.top = (Math.random()*0.9)+0.05;
						
						this.spawn.active = true;
						this.spawn.type = request.data.type;
						this.spawn.unique_id = request.data.unique_id;
						this.spawn.biome = request.data.biome;
						
						var dt = new Date();
						dt.setSeconds( dt.getSeconds() + 600 );
						this.spawn.expiration = dt.getTime();
						
						this.spawn.expiration_timeout = setTimeout(this.checkVairusExpiration, 600*1000);
						
						//Animazione speciale per le cache
						if(request.data.type == 'treasure'){
							if(this.checkOption('advanced_animations') && !this.animation_started){
								var styleNode = document.createElement ("style");
								styleNode.type = "text/css";
								styleNode.textContent = ".vairus-glitch{ position:relative; }.vairus-glitch:before{ content: attr(data-text);position: absolute;top: 0;left: 0 !important;width: 100%;height: 100%;clip: rect(0, 0, 0, 0);text-shadow: -2px 0 #ff00c1;animation: glitch-anim 1s infinite linear alternate-reverse; } @keyframes glitch-anim {0% {clip: rect(47px, 9999px, 21px, 0);transform: skew(0.21deg);}5% {clip: rect(23px, 9999px, 77px, 0);transform: skew(0.9deg);}10% {clip: rect(56px, 9999px, 84px, 0);transform: skew(0.34deg);}15% {clip: rect(88px, 9999px, 14px, 0);transform: skew(0.29deg);}20% {clip: rect(31px, 9999px, 51px, 0);transform: skew(0.75deg);}25% {clip: rect(41px, 9999px, 48px, 0);transform: skew(0.41deg);}30% {clip: rect(24px, 9999px, 55px, 0);transform: skew(0.37deg);}35% {clip: rect(14px, 9999px, 13px, 0);transform: skew(0.94deg);}40% {clip: rect(69px, 9999px, 10px, 0);transform: skew(0.74deg);}45% {clip: rect(63px, 9999px, 95px, 0);transform: skew(0.45deg);}50% {clip: rect(34px, 9999px, 4px, 0);transform: skew(0.28deg);}55% {clip: rect(44px, 9999px, 10px, 0);transform: skew(0.22deg);}60% {clip: rect(96px, 9999px, 99px, 0);transform: skew(0.47deg);}65% {clip: rect(67px, 9999px, 42px, 0);transform: skew(0.1deg);}70% {clip: rect(8px, 9999px, 85px, 0);transform: skew(0.4deg);}75% {clip: rect(44px, 9999px, 32px, 0);transform: skew(0.64deg);}80% {clip: rect(61px, 9999px, 67px, 0);transform: skew(0.08deg);}85% {clip: rect(10px, 9999px, 72px, 0);transform: skew(0.34deg);}90% {clip: rect(57px, 9999px, 59px, 0);transform: skew(0.03deg);}95% {clip: rect(39px, 9999px, 87px, 0);transform: skew(0.91deg);}100% {clip: rect(26px, 9999px, 40px, 0);transform: skew(0.93deg);}}";
								document.head.appendChild (styleNode);
								
								document.body.style['overflow-x'] = 'hidden';
								all_elements = document.querySelectorAll('*:not(html, head, title, link, meta, script, style, noscript, body, ul, .spawn, #vairus-vue-app, #vairus-root)');
								all_elements = Array.from(all_elements);
								
								this.glitchElement();
							}
						}
					break;
					case 'click_spawn_result':
						switch(request.data.type){
							case 'vairus' : 
								if(request.success){
									if(!this.checkOption('hide_vairus_popup') && this.show_popup){
										this.vairus_catch.vairus = request.data.vairus;
										this.vairus_catch.bytes = request.data.bytes;
									}
									
									this.vairus_catch.active = true;
									this.vairus_catch.shards = request.data.shards;
									
									//Tutorials
									if(!this.checkTutorial('first_catch')){
										setTimeout(function(){
											this.setTutorial('first_catch', true);
										}.bind(this), 1000)
									}

								
									if(request.data.list_length >= 10 && !this.checkTutorial('first_objective')){
										setTimeout(function(){
											this.setTutorial('first_objective', true);
										}.bind(this), 500)
									}
								}else{
									this.addNotification('catch_failed');
								}
							break;
							case 'treasure' :
								if(request.success){
									if(!this.checkOption('hide_vairus_popup') && this.show_popup){
										this.treasure_rewards = request.data;
									}
								}else{
									this.addNotification('treasure_failed');
								}
							break;
						}
					break;
					case 'spawn_limit':
						this.addNotification(request.limit+'_limit');
					break;
					case 'spawn_matrix':
						if(this.checkTutorial('introduction')){
							if(typeof request.data.vairus == 'undefined' || !this.checkOption('hide_completed_matrix')){
								this.addNotification('matrix_spawn', 'orange');
								this.matrix.status = 'spawn';
								this.matrix.level = request.data.level;
								this.matrix.expiration = request.data.expiration;
								this.matrix.assigned_vairus = request.data.vairus;
								this.matrix.current_score = request.data.current_score;
								this.matrix.current_vairus = request.data.current_vairus;
								this.matrix.current_users = request.data.current_users;
								this.matrix.progress = request.data.progress;
								this.matrix.score_boost = request.data.score_boost;
								this.matrix.main_stat = request.data.main_stat;
								this.matrix.secondary_stat = request.data.secondary_stat;
								this.matrix.energy_left = request.data.energy;
								
								if(!this.checkTutorial('matrix')){
									setTimeout(function(){
										this.setTutorial('matrix', true);
									}.bind(this), 500)
								}
							}
						}
						
						//Animazione avanzata per le matrici
						if(this.checkOption('advanced_animations') && !this.animation_started && !this.checkOption('hide_completed_matrix')){
							this.animation_started = true;
							var styleNode = document.createElement ("style");
							styleNode.type = "text/css";
							styleNode.textContent = ".vairus-removed{visibility: hidden;} .vairus-attracted{ animation: attraction 2.1s infinite linear; } @keyframes attraction {from {transform: rotate(0deg) scale(1);}to { transform: rotate(359deg) scale(0);}};";
							document.head.appendChild (styleNode);
	
							document.body.style['overflow-x'] = 'hidden';
							all_elements = document.querySelectorAll('*:not(html, head, title, link, meta, script, style, noscript, body, li, p, span, .spawn, #vairus-vue-app, #vairus-root)');
							all_elements = Array.from(all_elements);
							
							this.absorbElement();
						}
					break;
					
					case 'analysis_request':
						this.analyze = true;
						this.analyzer = request.data;
						this.old_analysis = request.analysis;
						this.probes = request.probes;
					break;
					
					case 'get_info_result':
						this.info_rewards = request.data;
					break;
					
					case 'generic_notification':
						this.addNotification(request.data.message, request.data.color);
					break;
				}
				
			}.bind(this));
		},
		methods: {
			checkOption(option){
				if(!this.options.hasOwnProperty(option)) return false;
				
				return this.options[option];
			},
			updateSize(){
				this.screen.width = Math.min(document.body.scrollWidth, window.innerWidth);
				this.screen.height = Math.max(document.body.scrollHeight, window.innerHeight);
			},
			closeCatch(){
				this.vairus_catch.vairus = null;
			},
			closeTreasure(){
				this.treasure_rewards = null;
			},
			addNotification(message, color = 'azure'){
				if(!this.checkOption('hide_notification')){
					var id = this.notifications_index;
					
					this.notifications.push({
						message:message,
						color:color,
						id : id
					});
					
					setTimeout(function(){
						this.removeNotification(0)
					}.bind(this), 5000);
					
					this.notifications_index = id+1;
				}
			},
			removeNotification(index){
				this.notifications.splice(index, 1);
			},
			openProfile(hash){
				let url = '/profile/profile.html';
				if(hash != null) url+= '#'+hash;
				window.open(browser.extension.getURL(url) , '_blank');
			},
			checkVairusExpiration(){
				if(this.spawn.expiration != null){
					var time_left = this.spawn.expiration - new Date().getTime();
				
					if(time_left <= 0){
						this.spawn.active = false;
						this.spawn.expiration = null;
					}else{
						clearTimeout(this.spawn.expiration_timeout);
						this.spawn.expiration_timeout = setTimeout(this.checkVairusExpiration, time_left);
					}
				}
			},
			clickSpawn(e, show_popup){
				e.preventDefault();
				this.spawn.active = false;
				this.show_popup = show_popup;
				
				if(e.isTrusted){
					browser.runtime.sendMessage({
						type : 'spawn_click',
						data : { unique_id : this.spawn.unique_id}
					});
				}
				
				if(this.spawn.type == 'treasure'){
					if(this.checkOption('advanced_animations')){
						this.animation_active = false;
						var elements = document.querySelectorAll('.vairus-glitch');
						elements.forEach(function(node){
							node.classList.remove('vairus-glitch');
						});
					}
				}
			},
			openMatrixInfo(){
				this.matrix.status = 'info';
				this.animation_active = false;
				
				if(!this.checkTutorial('matrix_details')){
					setTimeout(function(){
						this.setTutorial('matrix_details', true);
					}.bind(this), 1000)
				}
				
				if(this.checkOption('advanced_animations')){
					var elements = document.querySelectorAll('.vairus-removed');
					elements.forEach(function(node){
						node.classList.remove('vairus-removed');
					});
				}
			},
			closeMatrix(e = null){
				if(e != null) e.preventDefault();
				this.matrix.status = false;
			},
			chooseVairusForMatrix(){
				this.vairus_list.reason = 'matrix'
				this.requestList();
			},
			requestList(){
				this.vairus_list.active = true;
				this.vairus_list.loading = true;
				
				if(this.vairus_list.list.length == 0){
					browser.runtime.sendMessage({
						type : 'request_list',
						data : {}
					}, function(response){
						this.vairus_list.list = response.vairus_list;
						this.boxes = [{"name":browser.i18n.getMessage('base_box'),"vairus":[]}].concat(response.boxes);
					}.bind(this));
				}
			},
			clickList(unique_id){
				switch(this.vairus_list.reason){
					case 'matrix':
						var vairus = this.vairus_list.list.find(function(v){ return v.unique_id == unique_id; })
						this.matrix.selected_vairus = vairus;
					break;
				}
				
				this.closeList();
			},
			closeList(){
				this.vairus_list.active = false;
			},
			listMounted(){
				this.vairus_list.loading = false;
			},
			setTutorial(flag, update = false, fast = false, color = 'azure'){
				this.$store.commit('setTutorial', {
					flag : flag,
					update : update,
					fast : fast,
					color : color
				});
			},
			closeTutorial(){
				this.$store.commit('closeTutorial');
			},
			checkSetTutorial(flag){
				if(!this.checkTutorial(flag)){
					this.setTutorial(flag, true, false, 'red');
				}
			},
			absorbElement(){
				if(all_elements.length < 1 || !this.animation_active) return;
				
				var random = Math.floor( Math.random() * all_elements.length );
				var el = all_elements[random];
				
				
				var childs = el.querySelectorAll('*');
				
				if(typeof el == 'undefined' || childs.length > 100){
					this.absorbElement();
					return;
				}
				
				childs.forEach(function(node){
					node.classList.add('vairus-flagged');
				});
				
				var el_width = el.offsetWidth;
				var el_height = el.offsetHeight;
				var el_offset_x = el.offsetLeft;
				var el_offset_y = el.offsetTop;

				var el_clone = el.cloneNode(true);
				el_clone.classList.add('vairus-attracted');
				el.classList.add('vairus-removed');
				el.classList.add('vairus-flagged');
				
				document.body.appendChild(el_clone);

				//* CSS */
				
				el_clone.style["position"] = "absolute";
				el_clone.style["width"] = el_width+'px';
				el_clone.style["height"] = el_height+'px';
				el_clone.style["top"] = el_offset_y+'px';
				el_clone.style["left"] = el_offset_x+'px';
				el_clone.style["transition"] = 'all 2s';
				el_clone.style["transform-origin"] = 'center';
				el_clone.style["z-index"] = 999999;

				setTimeout(function(){
					el_clone.style['top'] = ((this.screen.height*0.5)-(el_height/2)) + 'px';
					el_clone.style['left'] = ((this.screen.width*0.5)-(el_width/2)) + 'px';
				}.bind(this), 1);
				
				setTimeout(function(){
					el_clone.parentNode.removeChild(el_clone);
				}.bind(null, el_clone), 2000);
				
				all_elements = all_elements.filter(function(node){
					return !node.classList.contains('vairus-flagged');
				});
				
				setTimeout(this.absorbElement, 50);
			},
			glitchElement(){
				if(all_elements.length < 10 || !this.animation_active) return;
				
				var random = Math.floor( Math.random() * all_elements.length );
				var el = all_elements[random];
				
				el.classList.add('vairus-glitch');
				el.setAttribute('data-text', el.textContent);
				
				var childs = el.querySelectorAll('*');
				
				if(typeof el == 'undefined' || childs.length > 100){
					this.glitchElement();
					return;
				}
				
				childs.forEach(function(node){
					node.classList.add('vairus-glitch');
					node.setAttribute('data-text', node.textContent);
				});
				
				all_elements = all_elements.filter(function(node){
					return !node.classList.contains('vairus-glitch');
				});
				
				setTimeout(this.glitchElement, 50);
			}
		},
		computed: {
			getSpawnStyle(){
				return {
					'left': (this.screen.width*this.spawn.position.left)+'px !important',
					'top': (this.screen.height*this.spawn.position.top)+'px !important',
				};
			},
			getSpawnImage(){
				switch(this.spawn.type){
					case 'vairus':
						return browser.runtime.getURL('/images/eggs/'+this.spawn.biome+'.png');
					break;
					case 'treasure':
						return browser.runtime.getURL('/images/cache.gif');
					break;
				}
			},
			getParticeStyle(){
				return {
					'left': (this.screen.width*this.spawn.position.left)+'px !important',
					'top': (this.screen.height*this.spawn.position.top)+'px !important'
				};
			},
			getMatrixStyle(){
				return {
					'left': ((this.screen.width*0.5)-20)+'px !important',
					'top': ((this.screen.height*0.5)-20)+'px !important',
					'background-image': 'url('+browser.runtime.getURL('/images/matrix.gif')+') !important'
				}
			},
			tooltipText(){
				return this.$store.state.tooltip.text;
			},
			tooltipStyle(){
				return {
					top : this.$store.state.tooltip.top+'px', 
					left : this.$store.state.tooltip.left+'px'
				};
			},
			current_tutorial() {
				return this.$store.state.current_tutorial;
			},
			tutorial_color() {
				return this.$store.state.tutorial_color;
			},
		},
		mixins: [commonMixin],
		components: {
			VButton,
			GlitchedImage,
			VairusList,
			VairusCatch,
			ShardParticle,
			TreasureRewards,
			MatrixInfo,
			InfoRewards,
			WebsiteAnalyzer,
			Tutorial
		}
	}
</script>


<style lang="scss">
	@import "../styles/variables";
	@import "../styles/styles";
	
	/* COLORS */

	.white-bkg{
		background-color: white;
	}
	.black-bkg{
		background-color: white;
	}

	.mountain-bkg,
	.earth-bkg{
		background-color: #B67341;
	}
	.sky-bkg,
	.air-bkg{
		background-color: #F2F2F2;
	}
	.desert-bkg,
	.fire-bkg{
		background-color: #FFCE4A;
	}
	.ocean-bkg,
	.water-bkg{
		background-color: #38A0D2;
	}
	.swamp-bkg,
	.acid-bkg{
		background-color: #E5E323;
	}
	.city-bkg,
	.electric-bkg{
		background-color: #BFD2D2;
	}
	.glacier-bkg,
	.ice-bkg{
		background-color: #48C4D2;
	}
	.forest-bkg,
	.nature-bkg{
		background-color: #7BA41D;
	}
	.glitch-bkg{
		background: radial-gradient(#e66465, #9198e5);
	}

	.mountain-border{
		border-color: #B67341;
	}
	.sky-border{
		border-color: #F2F2F2;
	}
	.desert-border{
		border-color: #FFCE4A;
	}
	.ocean-border{
		border-color: #38A0D2;
	}
	.swamp-border{
		border-color: #E5E323;
	}
	.city-border{
		border-color: #BFD2D2;
	}
	.glacier-border{
		border-color: #48C4D2;
	}
	.forest-border{
		border-color: #7BA41D;
	}
	
	/* OTHER */
	
	#vairus-vue-app{
		position: absolute;
		left: 0;
		top: 0;
		width: 100%;
		font-family: ChakraPetch;
		font-size: 16px;
	}
		
	.spawn{
		position: absolute;
		width: 60px;
		height: 60px;
		cursor: pointer;
		z-index: 2147483647;
		background-size: cover;
		
		&.treasure{
			width: 60px;
			height: 60px;
		}
		&.matrix{
			width: 60px;
			height: 60px;
		}
	}
	.vairus-messages{
		position: fixed;
		bottom: 10px;
		right: 0;
		z-index: 2147483647;
		
		.vairus-message{
			position: absolute;
			bottom: 0;
			right: 0;
			line-height: 18px;
			padding: 10px 20px;
			margin-right: 20px;
			border-radius: 5px;
			white-space: nowrap;
			transition: bottom 0.2s cubic-bezier(.47,1.64,.41,.8);
			cursor: pointer;
		}
		
		@media screen and (max-width: 650px) {
			p{
				display: flex;
				flex-direction: column-reverse;
				align-items: flex-end;
				
				.vairus-message{
					position: initial;
					margin-top: 5px;
					max-width: 90vw;
					white-space: initial;
					text-align: right;
				}
			}
		}
	}
	.vairus-list-container{
		position: fixed;
		top: 0;
		left: 0;
		width: 100%;
		height: 100%;
		z-index: 2147483647;
		
		.main-column{
			height: 100%;
		
			.inner{
				position: absolute;
				top: 5%;
				left: 0;
				width: 100%;
				height: 90%;
				overflow-y: auto;
				color: white;
				border-radius: 10px;
				
				> .wrapper{
					padding: 20px;
				}
				
				&::-webkit-scrollbar {
					width: 8px;
				}
				&::-webkit-scrollbar-track {
					background-color: #4A3349;
				}
				&::-webkit-scrollbar-thumb {
					background-color: $darkazure;
				}
			}
		}
	}

	.shard-particles{
		position: absolute;
		width: 60px;
		height: 60px;
		z-index: 2147483647;
		pointer-events: none;
	}

	.tooltip{
		position: fixed;
		padding: 10px;
		background-color: #11070F;
		color: white;
		z-index: 2147483647;
		max-width: 200px;
	}


	/* ANIMATION */


	@keyframes shake {
	  0% { transform: translate(0.5px, 0.5px) rotate(0deg); }
	  3% { transform: translate(-0.5px, -1px) rotate(-5deg); }
	  6% { transform: translate(-1px, 0px) rotate(5deg); }
	  9% { transform: translate(1px, 1px) rotate(0deg); }
	  12% { transform: translate(0.5px, -0.5px) rotate(5deg); }
	  15% { transform: translate(-0.5px, 1px) rotate(-5deg); }
	  18% { transform: translate(-1px, 0.5px) rotate(0deg); }
	  24% { transform: translate(1px, 0.5px) rotate(-5deg); }
	  27% { transform: translate(-0.5px, -0.5px) rotate(5deg); }
	  30% { transform: translate(0.5px, 1px) rotate(0deg); }
	  33% { transform: translate(0.5px, -1px) rotate(-5deg); }
	  36% { transform: translate(0) rotate(0); }
	}


	/* VUE TRANSITION */

	#vairus-vue-app .message-enter-active,
	#vairus-vue-app .message-leave-active {
		transition: all 0.2s;
	}
	#vairus-vue-app .message-enter{
		right: -200px;
	}
	#vairus-vue-app .message-leave-to{
	  opacity: 0;
	}
</style>